package org.drools.prepare.collection;

import java.util.Collection;

import org.drools.KnowledgeBase;
import org.drools.KnowledgeBaseFactory;
import org.drools.builder.KnowledgeBuilder;
import org.drools.builder.KnowledgeBuilderFactory;
import org.drools.builder.ResourceType;
import org.drools.definition.KnowledgePackage;
import org.drools.io.ResourceFactory;
import org.drools.logger.KnowledgeRuntimeLogger;
import org.drools.logger.KnowledgeRuntimeLoggerFactory;
import org.drools.runtime.StatefulKnowledgeSession;

public class RuleRunnerKnowledgeAgent {
	private KnowAgent myKnowAgent = new KnowAgent();
	private KnowledgeBase kbase = KnowledgeBaseFactory
								  .newKnowledgeBase();
	private KnowledgeRuntimeLogger logger;
	private StatefulKnowledgeSession ksession;

	public RuleRunnerKnowledgeAgent() {
    }

    public void RuleRunnerKnowledgeAgent(String[] rules,
                         Object[] facts) throws Exception {

        
        /*KnowledgeBuilder kbuilder = KnowledgeBuilderFactory.newKnowledgeBuilder();

        for ( int i = 0; i < rules.length; i++ ) {
            String ruleFile = rules[i];
            System.out.println( "Loading file: " + ruleFile );
            kbuilder.add( ResourceFactory.newClassPathResource( ruleFile,
                                                                RuleRunnerKnowledgeAgent.class ),
                                  ResourceType.DRL );
        }
        
        Collection<KnowledgePackage> pkgs = kbuilder.getKnowledgePackages();
        kbase.addKnowledgePackages( pkgs );*/
        kbase = myKnowAgent.buildKBA(kbase);
        
        ksession = kbase.newStatefulKnowledgeSession();
        logger = KnowledgeRuntimeLoggerFactory.newFileLogger(ksession, "agentkblog");
        
        /*for ( int i = 0; i < facts.length; i++ ) {
            Object fact = facts[i];
            System.out.println( "Inserting fact: " + fact );
            ksession.insert( fact );
        }*/
        ksession.fireAllRules();
		//logger.close();
		//ksession.dispose();
    }
}